#include "pixman.h"
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>

static pixman_image_t * create_bits_image(pixman_image_t*(*create_bits_func)(pixman_format_code_t, int, int, uint32_t*, int)) {

  pixman_format_code_t format = (pixman_format_code_t)134316032;
  int width = 12;
  int height = 132;
  uint32_t* bits = NULL;
  int stride = -1;

  pixman_image_t* image = create_bits_func(format, width, height, bits, stride);
  if (!image) {
    return NULL;
  }
  return image;
}

int main() {
  void* handle = dlopen(".libs/libpixman-1.so", RTLD_LAZY);
  if (!handle) { printf("Couldn't open libpixman.\n"); return -1; }
  
  pixman_image_t*(*img_create_bits_func)(pixman_format_code_t, int, int, uint32_t*, int);
  void(*rast_trap_func)(pixman_image_t*, const pixman_trapezoid_t*, int, int);

  *(void**)(&img_create_bits_func) = dlsym(handle, "pixman_image_create_bits");
  if (!img_create_bits_func) { 
    printf("no create bits\n"); 
    return -1; 
  }
  *(void**)(&rast_trap_func) = dlsym(handle, "pixman_rasterize_trapezoid");
  if (!rast_trap_func) { 
    printf("no trap\n"); 
    return -1; 
  }

  pixman_image_t* image = create_bits_image(img_create_bits_func);
  pixman_trapezoid_t* trap = malloc(sizeof(pixman_trapezoid_t));
  trap->top = 0x80000000;
  trap->bottom = 0x80000700;
  trap->right.p1.x = 0x835ad00;
  trap->right.p1.y = 0x80000000;
  trap->right.p2.x = 0x843c300;
  trap->right.p2.y = 0x80000700;
  trap->left.p1.x = 0xf742fe00;
  trap->left.p1.y = 0x80000000;
  trap->left.p2.x = 0xf7343600;
  trap->left.p2.y= 0x80000700;
  rast_trap_func(image, trap, 0, 0);
}
